Index: main/trunk/model-cols-dev/peijones/js/annotator/pkg/annotator-full.min.js
===================================================================
--- main/trunk/model-cols-dev/peijones/js/annotator/pkg/annotator-full.min.js	(revision 25068)
+++ main/trunk/model-cols-dev/peijones/js/annotator/pkg/annotator-full.min.js	(revision 25075)
@@ -639,5 +639,6 @@
 
 			var rangeString = u.ranges[0].startOffset + "_" + u.ranges[0].endOffset;
-						
+			
+			/*
 			var found = false;
 			for(var i = 0; i < gs.annotationArray.keys.length; i++){if(gs.annotationArray.keys[i] == rangeString){found = true; break;}}
@@ -649,4 +650,6 @@
 			gs.annotationArray[rangeString] = u;
 			console.log("(setup) Adding " + u.quote + ", " + u.text + ", " + u.tags + " to " + rangeString);
+			showRebuildOption();
+			*/
             return u
         };
@@ -659,5 +662,5 @@
             var w, v, y, x;
             x = u.highlights;
-			
+		
             for (v = 0, y = x.length; v < y; v++) {
                 w = x[v];
@@ -666,8 +669,8 @@
 			
 			var rangeString = u.ranges[0].startOffset + "_" + u.ranges[0].endOffset;
-			gs.toDeleteArray[rangeString] = gs.annotationArray[rangeString];
+			gs.toDeleteArray[rangeString] = u;
 			gs.toDeleteArray.keys.push(rangeString);
 			gs.annotationArray[rangeString] = null;
-			
+			showRebuildOption();
             this.publish("annotationDeleted", [u]);
             return u
@@ -1593,4 +1596,5 @@
 			gs.annotationArray[rangeString] = u;
 			console.log("(setup) Adding " + u.quote + ", " + u.text + ", " + u.tags + " to " + rangeString);
+			showRebuildOption();
             return h(u.highlights).data("annotation", u)
         };
@@ -2066,4 +2070,5 @@
                 })
             }
+			/*
             if (this.options.showEditPermissionsCheckbox === true) {
                 this.annotator.editor.addField({
@@ -2074,4 +2079,6 @@
                 })
             }
+			*/
+			console.log(this.annotator.editor);
             this.annotator.viewer.addField({
                 load: this.updateViewer
Index: main/trunk/model-cols-dev/peijones/js/documentmaker/PhotoNotes-1.5.js
===================================================================
--- main/trunk/model-cols-dev/peijones/js/documentmaker/PhotoNotes-1.5.js	(revision 25068)
+++ main/trunk/model-cols-dev/peijones/js/documentmaker/PhotoNotes-1.5.js	(revision 25075)
@@ -1,7 +1,5 @@
 
-
-/*********************************************************/
 /*** Photo Notes Container *******************************/
-/*********************************************************/
+
 function PhotoNoteContainer(element, config)
 {
@@ -79,9 +77,6 @@
 };
 
-
-
-/*********************************************************/
 /*** Photo Note ******************************************/
-/*********************************************************/
+
 function PhotoNote(text,id,rect)
 {
@@ -410,5 +405,5 @@
             {
                 this.maxRight = currentNote.container.element.offsetWidth;
-                this.maxBottom = currentNote.container.element.offsetHeight - 3;
+                this.maxBottom = currentNote.container.element.offsetHeight + $("#noZoom").position().top - 3;
                 return true;
             }
@@ -443,5 +438,5 @@
         {
             currentNote.rect.left = parseInt(this.element.style.left);
-            currentNote.rect.top = parseInt(this.element.style.top);
+            currentNote.rect.top = parseInt(this.element.style.top) - $("#noZoom").position().top;
             currentNote.rect.width = parseInt(this.element.style.width);
             currentNote.rect.height = parseInt(this.element.style.height);
@@ -467,5 +462,5 @@
     /* outer most box */
     this.gui.ElementRect.style.left  = this.rect.left + 'px';
-    this.gui.ElementRect.style.top  = this.rect.top + 'px';
+    this.gui.ElementRect.style.top  = this.rect.top + $("#noZoom").position().top + 'px';
     this.gui.ElementRect.style.width  = this.rect.width + 'px';
     this.gui.ElementRect.style.height  = this.rect.height + 'px';
@@ -484,5 +479,5 @@
  
     this.gui.ElementNote.style.left  = this.rect.left + this.XOffset + 'px';
-    this.gui.ElementNote.style.top  = this.rect.top + this.YOffset + this.rect.height + 'px';
+    this.gui.ElementNote.style.top  = this.rect.top + this.YOffset + this.rect.height + $("#noZoom").position().top + 'px';
    
 }
@@ -626,5 +621,5 @@
         minWidth: 10, minHeight: 10,     // Minimum pixel size of elements.
         minLeft: 0, maxRight: 9999,      // Bounding box area.
-        minTop: 0, maxBottom: 9999,
+        minTop: $("#noZoom").position().top, maxBottom: 9999,
         zIndex: 1,                       // The highest Z-Index yet allocated.
         mouseX: 0, mouseY: 0,            // Current mouse position, recorded live.
@@ -696,5 +691,5 @@
         // Record element attributes for mouseMove().
         elmX = parseInt(element.style.left);
-        elmY = parseInt(element.style.top);
+        elmY = parseInt(element.style.top + $("#noZoom").position().top);
         elmW = element.offsetWidth;
         elmH = element.offsetHeight;