Index: /main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml
===================================================================
--- /main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml	(revision 25107)
+++ /main/trunk/model-cols-dev/peijones/etc/collectionConfig.xml	(revision 25108)
@@ -92,6 +92,5 @@
 		<!--
 		<link rel="stylesheet" href="http://twitter.github.com/bootstrap/1.4.0/bootstrap.min.css"/>
-		<link rel="stylesheet" href="http://blueimp.github.com/Bootstrap-Image-Gallery/bootstrap-image-gallery.min.css"/>
-		-->
+		<link rel="stylesheet" href="http://blueimp.github.com/Bootstrap-Image-Gallery/bootstrap-image-gallery.min.css"/> -->
 		<!--[if lt IE 7]><link rel="stylesheet" href="http://blueimp.github.com/Bootstrap-Image-Gallery/bootstrap-ie6.min.css"><![endif]-->
 		<!--
@@ -111,6 +110,6 @@
         </script>
 		
-		<script src="http://blueimp.github.com/JavaScript-Templates/tmpl.min.js"><xsl:text> </xsl:text></script>
-		<script src="http://blueimp.github.com/JavaScript-Load-Image/load-image.min.js"><xsl:text> </xsl:text></script>
+		<script src="sites/localsite/collect/peijones/js/jQuery-File-Upload/tmpl.min.js"><xsl:text> </xsl:text></script>
+		<script src="sites/localsite/collect/peijones/js/jQuery-File-Upload/load-image.min.js"><xsl:text> </xsl:text></script>
 		-->
 		<!--<script id="template-upload" type="text/html">
@@ -709,14 +708,14 @@
 				{
 					// Include AnnotateIt credentials to load the store plugin.
-					$('#gs-document-text').annotator().annotator('setupPlugins', {
-						userId:    'papitha',
-						userName:  'Papitha',
-						accountId: '39fc339cf058bd22176771b3e33c5dac',
-						authToken: '852b7fc25396d2aedf9aeb44dd58518faa679dbf027892164bfb81900bd09741',	
-				//	 $('#gs-document-text').annotator().annotator('setupPlugins', {
-					//	userId:    'david',
-					//	userName:  'David',
-					//	accountId: 'eb096fae65f6377160ffc0eb6c000951',
-					//	authToken: '92b3279a6b6edbaa2ed7bc4d895ef55c8f1368877bb69987985aa47195d517e7',	
+				//	$('#gs-document-text').annotator().annotator('setupPlugins', {
+					//	userId:    'papitha',
+					//	userName:  'Papitha',
+					//	accountId: '39fc339cf058bd22176771b3e33c5dac',
+					//	authToken: '852b7fc25396d2aedf9aeb44dd58518faa679dbf027892164bfb81900bd09741',	
+					 $('#gs-document-text').annotator().annotator('setupPlugins', {
+						userId:    'david',
+						userName:  'David',
+						accountId: 'eb096fae65f6377160ffc0eb6c000951',
+						authToken: '92b3279a6b6edbaa2ed7bc4d895ef55c8f1368877bb69987985aa47195d517e7',	
 					}, {
 						Store: 
@@ -782,5 +781,5 @@
 			<xsl:text>;</xsl:text>
         </script>
-		<span style="font-size:90%; padding: 3px; cursor:pointer;" class="ui-state-default ui-corner-top" onclick="AddNote();">New photo annotation</span>
+		<span class="ui-state-default ui-corner-top" onclick="AddNote();" style="font-size:90%; padding: 3px; cursor:pointer;">New photo annotation</span>
         <div id="noZoom" style="display:block;">
 			<img id="noZoomImage" style="width: {$screenImageWidth}px; height: {$screenImageHeight}px;">
@@ -873,12 +872,12 @@
 				<script src="sites/localsite/collect/peijones/js/jQuery-File-Upload/application.js"><xsl:text> </xsl:text></script>
 
-				<script src="http://blueimp.github.com/cdn/js/bootstrap.min.js"><xsl:text> </xsl:text></script>
-				<script src="http://blueimp.github.com/Bootstrap-Image-Gallery/bootstrap-image-gallery.min.js"><xsl:text> </xsl:text></script>
+				<script src="sites/localsite/collect/peijones/js/jQuery-File-Upload/bootstrap.min.js"><xsl:text> </xsl:text></script>
+				<script src="sites/localsite/collect/peijones/js/jQuery-File-Upload/bootstrap-image-gallery.min.js"><xsl:text> </xsl:text></script>
 
 				<link href="sites/localsite/collect/peijones/js/jQuery-File-Upload/jquery.fileupload-ui.css" rel="stylesheet"/>
-				<link href="http://blueimp.github.com/cdn/css/bootstrap.min.css" rel="stylesheet"/>
-				<link href="http://blueimp.github.com/cdn/css/bootstrap-responsive.min.css" rel="stylesheet"/>
+				<link href="sites/localsite/collect/peijones/js/jQuery-File-Upload/bootstrap.min.css" rel="stylesheet"/>
+				<link href="sites/localsite/collect/peijones/js/jQuery-File-Upload/bootstrap-responsive.min.css" rel="stylesheet"/>
 				<!--[if lt IE 7]><link rel="stylesheet" href="http://blueimp.github.com/cdn/css/bootstrap-ie6.min.css"><![endif]-->
-				<link href="http://blueimp.github.com/Bootstrap-Image-Gallery/bootstrap-image-gallery.min.css" rel="stylesheet"/>
+				<link href="sites/localsite/collect/peijones/js/jQuery-File-Upload/cors/bootstrap-image-gallery.min.css" rel="stylesheet"/>
 
 				<script type="text/javascript">